diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/attribute-container.h ns-3.32/src/core/model/attribute-container.h
--- ns-3.31/src/core/model/attribute-container.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.32/src/core/model/attribute-container.h	2020-10-06 15:35:43.000000000 -0700
@@ -0,0 +1,490 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 Caliola Engineering, LLC.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Jared Dulmage <jared.dulmage@caliola.com>
+ */
+
+#ifndef ATTRIBUTE_CONTAINER_H
+#define ATTRIBUTE_CONTAINER_H
+
+#include <ns3/attribute-helper.h>
+#include <ns3/string.h>
+
+#include <list>
+#include <algorithm>
+#include <iterator>
+#include <sstream>
+#include <typeinfo>
+#include <type_traits>
+#include <utility>
+
+namespace ns3 {
+
+class AttributeChecker;
+
+// A = attribute value type, C = container type to return
+/**
+ * A container for one type of attribute.
+ * 
+ * The container uses \ref A to parse items into elements.
+ * Internally the container is always a list but an instance
+ * can return the items in a container specified by \ref C.
+ * 
+ * @tparam A AttributeValue type to be contained.
+ * @tparam C Possibly templated container class returned by Get.
+ */
+template <class A, template<class...> class C=std::list>
+class AttributeContainerValue : public AttributeValue
+{
+public:
+  /** AttributeValue (element) type. */
+  typedef A attribute_type;
+  /** Type actually stored within the container. */
+  typedef Ptr<A> value_type;
+  /** Internal container type. */
+  typedef std::list<value_type> container_type;
+  /** stl-style Const iterator type. */
+  typedef typename container_type::const_iterator const_iterator;
+  /** stl-style Non-const iterator type. */
+  typedef typename container_type::iterator iterator;
+  /** Size type for container. */
+  typedef typename container_type::size_type size_type;
+  /** NS3 style iterator type. */
+  typedef typename AttributeContainerValue::const_iterator Iterator; // NS3 type
+
+  // use underlying AttributeValue to get return element type
+  /** Item type of container returned by Get. */
+  typedef typename std::result_of<decltype(&A::Get)(A)>::type item_type;
+  /** Type of container returned. */
+  typedef C<item_type> result_type;
+
+  /**
+   * Default constructor.
+   * \param[in] sep Character separator between elements for parsing.
+   */
+  AttributeContainerValue (char sep = ',');
+
+  /**
+   * Construct from another container.
+   * @tparam CONTAINER[deduced] type of container passed for initialization.
+   * \param c Instance of CONTAINER with which to initialize AttributeContainerValue.
+   */
+  template <class CONTAINER>
+  AttributeContainerValue (const CONTAINER &c);
+
+  /**
+   * Construct from iterators.
+   * @tparam ITER[deduced] type of iterator.
+   * \param[in] begin Iterator that points to first initialization item.
+   * \param[in] end Iterator that points ones past last initialization item.
+   */
+  template <class ITER>
+  AttributeContainerValue (const ITER begin, const ITER end);
+
+  /** Destructor. */
+  ~AttributeContainerValue ();
+
+  // Inherited
+  Ptr<AttributeValue> Copy (void) const;
+  bool DeserializeFromString (std::string value, Ptr<const AttributeChecker> checker);
+  std::string SerializeToString (Ptr<const AttributeChecker> checker) const;
+
+  // defacto pure virtuals to integrate with built-in accessor code
+  /**
+   * Return a container of items.
+   * \return Container of items.
+   */
+  result_type Get (void) const;
+  /**
+   * Copy items from container c.
+   * 
+   * This method assumes \ref c has stl-style begin and end methods.
+   * The AttributeContainerValue value is cleared before copying from \ref c.
+   * @tparam T type of container.
+   * \param c Container from which to copy items.
+   */
+  template <class T>
+  void Set (const T &c);
+
+  // NS3 interface
+  /**
+   * NS3-style Number of items.
+   * \return Number of items in container.
+   */
+  size_type GetN (void) const;
+  /**
+   * NS3-style beginning of container.
+   * \return Iterator pointing to first time in container.
+   */
+  Iterator Begin (void);
+  /**
+   * NS3-style ending of container.
+   * \return Iterator pointing one past last item of container.
+   */
+  Iterator End (void);
+
+  // STL-interface
+  /**
+   * STL-style number of items in container
+   * \return number of items in container.
+   */
+  size_type size (void) const;
+  /**
+   * STL-style beginning of container.
+   * \return Iterator pointing to first item in container.
+   */
+  iterator begin (void);
+  /**
+   * STL-style end of container.
+   * \return Iterator pointing to one past last item in container.
+   */
+  iterator end (void);
+  /**
+   * STL-style const beginning of container.
+   * \return Const iterator pointing to first item in container.
+   */
+  const_iterator begin (void) const;
+  /**
+   * STL-style const end of container.
+   * \return Const iterator pointing to one past last item in container.
+   */
+  const_iterator end (void) const;
+
+private:
+  /**
+   * Copy items from \ref begin to \ref end. 
+   * 
+   * The internal container is cleared before values are copied
+   * using the push_back method.
+   * @tparam ITER[deduced] iterator type
+   * \param[in] begin Points to first item to copy
+   * \param[in] end Points to one after last item to copy
+   * \return This object with items copied.
+   */
+  template <class ITER>
+  Ptr<AttributeContainerValue<A, C> > CopyFrom (const ITER begin, const ITER end);
+
+  char m_sep;                 //!< Item separator
+  container_type m_container; //!< Internal container
+};
+
+class AttributeContainerChecker : public AttributeChecker
+{
+public:
+  virtual void SetItemChecker (Ptr<const AttributeChecker> itemchecker) = 0;
+  virtual Ptr<const AttributeChecker> GetItemChecker (void) const = 0;
+};
+
+/**
+ * Make AttributeContainerChecker from AttributeContainerValue.
+ * @tparam A[deduced] AttributeValue type in container.
+ * @tparam C[deduced] Container type returned by Get.
+ * \param value[in] AttributeContainerValue from which to deduce types.
+ * \return AttributeContainerChecker for \ref value.
+ */
+template <class A, template <class...> class C>
+Ptr<AttributeChecker>
+MakeAttributeContainerChecker (const AttributeContainerValue<A, C> &value);
+
+/**
+ * Make AttributeContainerChecker using explicit types, initialize item checker.
+ * @tparam A AttributeValue type in container.
+ * @tparam C Container type returned by Get.
+ * \param itemchecker[in] AttributeChecker used for each item in the container.
+ * \return AttributeContainerChecker.
+ */
+template <class A, template <class...> class C=std::list>
+Ptr<const AttributeChecker>
+MakeAttributeContainerChecker (Ptr<const AttributeChecker> itemchecker);
+
+/**
+ * Make unitialized AttributeContainerChecker using explicit types.
+ * @tparam A AttributeValue type in container.
+ * @tparam C Container type returned by Get.
+ * \return AttributeContainerChecker.
+ */
+template <class A, template <class...> class C=std::list>
+Ptr<AttributeChecker> MakeAttributeContainerChecker (void);
+
+template <typename A, template <typename...> class C=std::list, typename T1>
+Ptr<const AttributeAccessor> MakeAttributeContainerAccessor (T1 a1);
+
+} // namespace ns3
+
+/*****************************************************************************
+ * Implementation below
+ *****************************************************************************/
+
+namespace ns3 {
+
+// This internal class defines templated AttributeContainerChecker class that is instantiated
+// in MakeAttributeContainerChecker. The non-templated base ns3::AttributeContainerChecker
+// is returned from that function. This is the same pattern as ObjectPtrContainer.
+
+namespace internal {
+
+template <class A, template <class...> class C>
+class AttributeContainerChecker : public ns3::AttributeContainerChecker
+{
+public:
+  AttributeContainerChecker (void);
+  explicit AttributeContainerChecker (Ptr<const AttributeChecker> itemchecker);
+  void SetItemChecker (Ptr<const AttributeChecker> itemchecker);
+  Ptr<const AttributeChecker> GetItemChecker (void) const;
+
+private:
+  Ptr<const AttributeChecker> m_itemchecker;
+};
+
+template <class A, template <class...> class C>
+AttributeContainerChecker<A, C>::AttributeContainerChecker (void)
+  : m_itemchecker (0)
+{}
+
+template <class A, template <class...> class C>
+AttributeContainerChecker<A, C>::AttributeContainerChecker (Ptr<const AttributeChecker> itemchecker)
+  : m_itemchecker (itemchecker)
+{}
+
+template <class A, template <class...> class C>
+void
+AttributeContainerChecker<A, C>::SetItemChecker (Ptr<const AttributeChecker> itemchecker)
+{
+  m_itemchecker = itemchecker;
+}
+
+template <class A, template <class...> class C>
+Ptr<const AttributeChecker>
+AttributeContainerChecker<A, C>::GetItemChecker (void) const
+{
+  return m_itemchecker;
+}
+
+} // namespace internal
+
+template <class A, template <class...> class C>
+Ptr<AttributeChecker>
+MakeAttributeContainerChecker (const AttributeContainerValue<A, C> &value)
+{
+  return MakeAttributeContainerChecker <A, C> ();
+}
+
+template <class A, template <class...> class C>
+Ptr<const AttributeChecker>
+MakeAttributeContainerChecker (Ptr<const AttributeChecker> itemchecker)
+{
+  auto checker = MakeAttributeContainerChecker <A, C> ();
+  auto acchecker = DynamicCast<AttributeContainerChecker> (checker);
+  acchecker->SetItemChecker (itemchecker);
+  return checker;
+}
+
+template <class A, template <class...> class C>
+Ptr<AttributeChecker>
+MakeAttributeContainerChecker (void)
+{
+  std::string containerType;
+  std::string underlyingType;
+  typedef AttributeContainerValue<A, C> T;
+  {
+    std::ostringstream oss;
+    oss << "ns3::AttributeContainerValue<" << typeid (typename T::attribute_type).name ()
+        << ", " << typeid (typename T::container_type).name () << ">";
+    containerType = oss.str ();
+  }
+
+  {
+    std::ostringstream oss;
+    oss << "ns3::Ptr<" << typeid (typename T::attribute_type).name () << ">";
+    underlyingType = oss.str ();
+  }
+
+  return MakeSimpleAttributeChecker<T, internal::AttributeContainerChecker<A, C> > (containerType, underlyingType);
+}
+
+template <class A, template <class...> class C>
+AttributeContainerValue<A, C>::AttributeContainerValue (char sep)
+  : m_sep (sep)
+{
+
+}
+
+template <class A, template <class...> class C>
+template <class CONTAINER>
+AttributeContainerValue<A, C>::AttributeContainerValue (const CONTAINER &c)
+  : AttributeContainerValue<A, C> (c.begin (), c.end ())
+{
+
+}
+
+template <class A, template <class...> class C>
+template <class ITER>
+AttributeContainerValue<A, C>::AttributeContainerValue (const ITER begin, const ITER end)
+  : AttributeContainerValue ()
+{
+  CopyFrom (begin, end);
+}
+
+template <class A, template <class...> class C>
+AttributeContainerValue<A, C>::~AttributeContainerValue ()
+{
+  m_container.clear ();
+}
+
+template <class A, template <class...> class C>
+Ptr<AttributeValue>
+AttributeContainerValue<A, C>::Copy (void) const
+{
+  auto c = Create<AttributeContainerValue<A, C> > ();
+  c->m_sep = m_sep;
+  c->m_container = m_container;
+  return c;
+}
+
+template <class A, template <class...> class C>
+bool
+AttributeContainerValue<A, C>::DeserializeFromString (std::string value, Ptr<const AttributeChecker> checker)
+{
+  auto acchecker = DynamicCast<const AttributeContainerChecker> (checker);
+  if (!acchecker) return false;
+
+  std::istringstream iss (value); // copies value
+  while (std::getline (iss, value, m_sep))
+    {
+      auto avalue = acchecker->GetItemChecker ()->CreateValidValue (StringValue (value));
+      if (!avalue) return false;
+
+      auto attr = DynamicCast <A> (avalue);
+      if (!attr) return false;
+
+      // TODO(jared): make insertion more generic?
+      m_container.push_back (attr);
+    }
+  return true;
+}
+
+template <class A, template <class...> class C>
+std::string
+AttributeContainerValue<A, C>::SerializeToString (Ptr<const AttributeChecker> checker) const
+{
+  std::ostringstream oss;
+  bool first = true;
+  for (auto attr: *this)
+    {
+      if (!first) oss << m_sep;
+      oss << attr->SerializeToString (checker);
+      first = false;
+    }
+  return oss.str ();
+}
+
+template <class A, template <class...> class C>
+typename AttributeContainerValue<A, C>::result_type
+AttributeContainerValue<A, C>::Get (void) const
+{
+  result_type c;
+  for (const value_type& a: *this)
+    c.insert (c.end (), a->Get ());
+  return c;
+}
+
+template <class A, template <class...> class C>
+template <class T>
+void
+AttributeContainerValue<A, C>::Set (const T &c)
+{
+  m_container.clear ();
+  CopyFrom (c.begin (), c.end ());
+}
+
+template <class A, template <class...> class C>
+typename AttributeContainerValue<A, C>::size_type
+AttributeContainerValue<A, C>::GetN (void) const
+{
+  return size ();
+}
+
+template <class A, template <class...> class C>
+typename AttributeContainerValue<A, C>::Iterator
+AttributeContainerValue<A, C>::Begin (void)
+{
+  return begin ();
+}
+
+template <class A, template <class...> class C>
+typename AttributeContainerValue<A, C>::Iterator
+AttributeContainerValue<A, C>::End (void)
+{
+  return end ();
+}
+
+template <class A, template <class...> class C>
+typename AttributeContainerValue<A, C>::size_type
+AttributeContainerValue<A, C>::size (void) const
+{
+  return m_container.size ();
+}
+
+template <class A, template <class...> class C>
+typename AttributeContainerValue<A, C>::iterator
+AttributeContainerValue<A, C>::begin (void)
+{
+  return m_container.begin ();
+}
+
+template <class A, template <class...> class C>
+typename AttributeContainerValue<A, C>::iterator
+AttributeContainerValue<A, C>::end (void)
+{
+  return m_container.end ();
+}
+
+template <class A, template <class...> class C>
+typename AttributeContainerValue<A, C>::const_iterator
+AttributeContainerValue<A, C>::begin (void) const
+{
+  return m_container.cbegin ();
+}
+
+template <class A, template <class...> class C>
+typename AttributeContainerValue<A, C>::const_iterator
+AttributeContainerValue<A, C>::end (void) const
+{
+  return m_container.cend ();
+}
+
+template <class A, template <class...> class C>
+template <class ITER>
+Ptr<AttributeContainerValue<A, C> >
+AttributeContainerValue<A, C>::CopyFrom (const ITER begin, const ITER end)
+{
+  for (ITER iter = begin; iter != end; ++iter)
+    {
+      m_container.push_back (Create<A> (*iter));
+    }
+  return this;
+}
+
+template <typename A, template <typename...> class C, typename T1>
+Ptr<const AttributeAccessor> MakeAttributeContainerAccessor (T1 a1)
+{
+  return MakeAccessorHelper<AttributeContainerValue<A, C> > (a1);
+}
+
+} // namespace ns3
+
+#endif // ATTRIBUTE_CONTAINER_H
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/cairo-wideint-private.h ns-3.32/src/core/model/cairo-wideint-private.h
--- ns-3.31/src/core/model/cairo-wideint-private.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/cairo-wideint-private.h	2020-10-06 15:35:43.000000000 -0700
@@ -217,10 +217,10 @@
   cairo_int64_t       rem;
 } cairo_quorem64_t;
 
-cairo_uquorem64_t I
+cairo_uquorem64_t cairo_I
 _cairo_uint64_divrem (cairo_uint64_t num, cairo_uint64_t den);
 
-cairo_quorem64_t I
+cairo_quorem64_t cairo_I
 _cairo_int64_divrem (cairo_int64_t num, cairo_int64_t den);
 
 /*
@@ -264,7 +264,7 @@
 #define                 _cairo_int128_add(a,b)      _cairo_uint128_add (a,b)
 #define                 _cairo_int128_sub(a,b)      _cairo_uint128_sub (a,b)
 #define                 _cairo_int128_mul(a,b)      _cairo_uint128_mul (a,b)
-cairo_int128_t I _cairo_int64x64_128_mul (cairo_int64_t a, cairo_int64_t b);
+cairo_int128_t  cairo_I _cairo_int64x64_128_mul (cairo_int64_t a, cairo_int64_t b);
 #define                 _cairo_int128_lsl(a,b)      _cairo_uint128_lsl (a,b)
 #define                 _cairo_int128_rsl(a,b)      _cairo_uint128_rsl (a,b)
 #define                 _cairo_int128_rsa(a,b)      _cairo_uint128_rsa (a,b)
@@ -330,17 +330,17 @@
   cairo_int128_t      rem;
 } cairo_quorem128_t;
 
-cairo_uquorem128_t I
+cairo_uquorem128_t cairo_I
 _cairo_uint128_divrem (cairo_uint128_t num, cairo_uint128_t den);
 
-cairo_quorem128_t I
+cairo_quorem128_t cairo_I
 _cairo_int128_divrem (cairo_int128_t num, cairo_int128_t den);
 
-cairo_uquorem64_t I
+cairo_uquorem64_t cairo_I
 _cairo_uint_96by64_32x64_divrem (cairo_uint128_t num,
                                  cairo_uint64_t  den);
 
-cairo_quorem64_t I
+cairo_quorem64_t cairo_I
 _cairo_int_96by64_32x64_divrem (cairo_int128_t num,
                                 cairo_int64_t  den);
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/command-line.cc ns-3.32/src/core/model/command-line.cc
--- ns-3.31/src/core/model/command-line.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/command-line.cc	2020-10-06 15:35:43.000000000 -0700
@@ -28,6 +28,10 @@
 #include "type-id.h"
 #include "string.h"
 
+#if defined (ENABLE_BUILD_VERSION)
+#include "version.h"
+#endif
+
 #include <algorithm>  // transform
 #include <cctype>     // tolower
 #include <cstdlib>    // exit, getenv
@@ -64,7 +68,7 @@
   std::string basename = SystemPath::Split (filename).back ();
   m_shortName = basename.substr (0, basename.rfind (".cc"));
 }
-  
+
 CommandLine::CommandLine (const CommandLine &cmd)
 {
   Copy (cmd);
@@ -137,7 +141,7 @@
   NS_LOG_FUNCTION (this << args.size () << args);
 
   PrintDoxygenUsage ();
-  
+
   m_nonOptionCount = 0;
 
   if (args.size () > 0)
@@ -328,11 +332,28 @@
     << "    --PrintGroup=[group]:        Print all TypeIds of group.\n"
     << "    --PrintTypeIds:              Print all TypeIds.\n"
     << "    --PrintAttributes=[typeid]:  Print all attributes of typeid.\n"
+    << "    --PrintVersion:              Print the ns-3 version.\n"
     << "    --PrintHelp:                 Print this help message.\n"
     << std::endl;
 }
 
 #include <unistd.h>  // getcwd
+std::string
+CommandLine::GetVersion () const
+{
+#if defined (ENABLE_BUILD_VERSION)
+  return Version::LongVersion ();
+#else
+  return std::string{"Build version support is not enabled, reconfigure with "
+         "--enable-build-version flag"};
+#endif
+}
+
+void
+CommandLine::PrintVersion (std::ostream & os) const
+{
+  os << GetVersion () << std::endl;
+}
 
 void
 CommandLine::PrintDoxygenUsage (void) const
@@ -344,7 +365,7 @@
     {
       return;
     }
- 
+
   if (m_shortName.size () == 0)
     {
       NS_FATAL_ERROR ("No file name on example-to-run; forgot to use CommandLine var (__FILE__)?");
@@ -356,19 +377,19 @@
                     m_nonOptions.begin () + m_NNonOptions);
 
   std::string outf = SystemPath::Append (std::string (envVar), m_shortName + ".command-line");
-  
+
   NS_LOG_INFO ("Writing CommandLine doxy to " << outf);
-  
+
   std::fstream os (outf, std::fstream::out);
 
-  
+
   os << "/**\n \\file " << m_shortName << ".cc\n"
      << "<h3>Usage</h3>\n"
      << "<code>$ ./waf --run \"" << m_shortName
      << (m_options.size ()  ? " [Program Options]" : "")
      << (nonOptions.size () ? " [Program Arguments]" : "")
      << "\"</code>\n";
-    
+
   if (m_usage.length ())
     {
       os << m_usage << std::endl;
@@ -577,6 +598,12 @@
       PrintHelp (std::cout);
       std::exit (0);
     }
+  if (name == "PrintVersion" || name == "version")
+    {
+      //Print the version, then exit the program
+      PrintVersion (std::cout);
+      std::exit (0);
+    }
   else if (name == "PrintGroups")
     {
       // method below never returns.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/command-line.h ns-3.32/src/core/model/command-line.h
--- ns-3.31/src/core/model/command-line.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/command-line.h	2020-10-06 15:35:43.000000000 -0700
@@ -64,9 +64,12 @@
    --PrintGroup=[group]:        Print all TypeIds of group.
    --PrintTypeIds:              Print all TypeIds.
    --PrintAttributes=[typeid]:  Print all attributes of typeid.
+   --PrintVersion:              Print the ns-3 version.
    --PrintHelp:                 Print this help message. \endverbatim
  *
- * The more common \c --help is a synonym for \c --PrintHelp; an example
+ * The more common \c \--version is a synonym for \c \--PrintVersion.
+ *
+ * The more common \c \--help is a synonym for \c \--PrintHelp; an example
  * is given below.
  *
  * CommandLine can also handle non-option arguments
@@ -82,7 +85,7 @@
  * In use, arguments are given in the form
  * \verbatim
    --arg=value --toggle first-non-option\endverbatim
- * Most arguments expect a value, as in the first form, \c --arg=value.
+ * Most arguments expect a value, as in the first form, \c \--arg=value.
  * Toggles, corresponding to boolean arguments, can be given in any of
  * the forms
  * \verbatim
@@ -98,28 +101,29 @@
  * will be the final value used.  For example,
  * \verbatim
    --arg=one --toggle=f --arg=another --toggle \endverbatim
- * The variable set by \c --arg will end up with the value \c "another";
- * the boolean set by \c --toggle will end up as \c true.
+ * The variable set by \c \--arg will end up with the value \c "another";
+ * the boolean set by \c \--toggle will end up as \c true.
  *
  * Because arguments can be repeated it can be hard to decipher what
  * value each variable ended up with, especially when using boolean toggles.
  * Suggested best practice is for scripts to report the values of all items
  * settable through CommandLine, as done by the example below.
  *
+ *
  * CommandLine can set the initial value of every attribute in the system
- * with the \c --TypeIdName::AttributeName=value syntax, for example
+ * with the \c \--TypeIdName::AttributeName=value syntax, for example
  * \verbatim
    --Application::StartTime=3s \endverbatim
  * In some cases you may want to highlight the use of a particular
  * attribute for a simulation script.  For example, you might want
  * to make it easy to set the \c Application::StartTime using
- * the argument \c --start, and have its help string show as part
+ * the argument \c \--start, and have its help string show as part
  * of the help message.  This can be done using the
  * \link AddValue(const std::string&, const std::string&) AddValue (name, attributePath) \endlink
  * method.
  *
  * CommandLine can also set the value of every GlobalValue
- * in the system with the \c --GlobalValueName=value syntax, for example
+ * in the system with the \c \--GlobalValueName=value syntax, for example
  * \verbatim
    --SchedulerType=HeapScheduler \endverbatim
  *
@@ -182,6 +186,7 @@
        --PrintGroup=[group]:        Print all TypeIds of group.
        --PrintTypeIds:              Print all TypeIds.
        --PrintAttributes=[typeid]:  Print all attributes of typeid.
+       --PrintVersion:              Print the ns-3 version.
        --PrintHelp:                 Print this help message. \endverbatim
  *
  * Having parsed the arguments, some programs will need to perform
@@ -225,7 +230,7 @@
   CommandLine (void);
   /**
    * Construct and register the source file name.
-   * This would typically be called by 
+   * This would typically be called by
    *     CommandLine cmd (__FILE__);
    *
    * This form is required to generate Doxygen documentation of the
@@ -253,7 +258,7 @@
   /**
    * Supply the program usage and documentation.
    *
-   * \param [in] usage Program usage message to write with \c --help.
+   * \param [in] usage Program usage message to write with \c \--help.
    */
   void Usage (const std::string usage);
 
@@ -261,7 +266,7 @@
    * Add a program argument, assigning to POD
    *
    * \param [in] name The name of the program-supplied argument
-   * \param [in] help The help text used by \c \-\-PrintHelp
+   * \param [in] help The help text used by \c \--PrintHelp
    * \param [out] value A reference to the variable where the
    *        value parsed will be stored (if no value
    *        is parsed, this variable is not modified).
@@ -283,7 +288,7 @@
    * Add a program argument, using a Callback to parse the value
    *
    * \param [in] name The name of the program-supplied argument
-   * \param [in] help The help text used by \c --help
+   * \param [in] help The help text used by \c \--help
    * \param [in] callback A Callback function that will be invoked to parse and
    *   store the value.
    * \param [in] defaultValue Optional default value for argument.
@@ -310,7 +315,7 @@
    * Add a non-option argument, assigning to POD
    *
    * \param [in] name The name of the program-supplied argument
-   * \param [in] help The help text used by \c \-\-PrintHelp
+   * \param [in] help The help text used by \c \--PrintHelp
    * \param [out] value A reference to the variable where the
    *        value parsed will be stored (if no value
    *        is parsed, this variable is not modified).
@@ -378,7 +383,7 @@
   /**
    * \brief Print program usage to the desired output stream
    *
-   * Handler for \c \-\-PrintHelp and \c \-\-help:  print Usage(), argument names, and help strings
+   * Handler for \c \--PrintHelp and \c \--help:  print Usage(), argument names, and help strings
    *
    * Alternatively, an overloaded operator << can be used:
    * \code
@@ -393,6 +398,22 @@
    */
   void PrintHelp (std::ostream &os) const;
 
+  /**
+   * Get the program version.
+   *
+   * \return The program version
+   */
+  std::string GetVersion () const;
+
+  /**
+   * Print ns-3 version to the desired output stream
+   *
+   * Handler for \c \--PrintVersion and \c \--version.
+   *
+   * \param [in,out] os The output stream to print on.
+   */
+  void PrintVersion (std::ostream &os) const;
+
 private:
 
   /**
@@ -402,7 +423,7 @@
   class Item
   {
   public:
-    std::string m_name;       /**< Argument label:  \c \-\--m_name=... */
+    std::string m_name;       /**< Argument label:  \c \--m_name=... */
     std::string m_help;       /**< Argument help string */
     virtual ~Item ();         /**< Destructor */
     /**
@@ -511,32 +532,32 @@
   static bool HandleAttribute (const std::string name, const std::string value);
 
   /**
-   * Handler for \c \-\-PrintGlobals:  print all global variables and values
+   * Handler for \c \--PrintGlobals:  print all global variables and values
    * \param [in,out] os The output stream to print on.
    */
   void PrintGlobals (std::ostream &os) const;
   /**
-   * Handler for \c \-\-PrintAttributes:  print the attributes for a given type.
+   * Handler for \c \--PrintAttributes:  print the attributes for a given type.
    *
    * \param [in,out] os the output stream.
    * \param [in] type The TypeId whose Attributes should be displayed
    */
   void PrintAttributes (std::ostream &os, const std::string &type) const;
   /**
-   * Handler for \c \-\-PrintGroup:  print all types belonging to a given group.
+   * Handler for \c \--PrintGroup:  print all types belonging to a given group.
    *
    * \param [in,out] os The output stream.
    * \param [in] group The name of the TypeId group to display
    */
   void PrintGroup (std::ostream &os, const std::string &group) const;
   /**
-   * Handler for \c \-\-PrintTypeIds:  print all TypeId names.
+   * Handler for \c \--PrintTypeIds:  print all TypeId names.
    *
    * \param [in,out] os The output stream.
    */
   void PrintTypeIds (std::ostream &os) const;
   /**
-   * Handler for \c \-\-PrintGroups:  print all TypeId group names
+   * Handler for \c \--PrintGroups:  print all TypeId group names
    *
    * \param [in,out] os The output stream.
    */
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/model/config.cc ns-3.32/src/core/model/config.cc
--- ns-3.31/src/core/model/config.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/model/config.cc	2020-10-06 15:35:43.000000000 -0700
@@ -899,7 +899,10 @@
 void ConnectWithoutContext (std::string path, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (path << &cb);
-  ConnectWithoutContextFailSafe (path, cb);
+  if (!ConnectWithoutContextFailSafe (path, cb))
+    {
+      NS_FATAL_ERROR ("Could not connect callback to " << path);
+    }
 }
 bool ConnectWithoutContextFailSafe (std::string path, const CallbackBase &cb)
 {
